<?PHP
define('MOBIO_VG_LINK_RECVGIFTS', 1);
define('MOBIO_VG_LINK_SENTGIFTS', 2);
define('MOBIO_VG_LINK_ALLGIFTS',  4);
define('MOBIO_VG_LINK_ALLGIFTS2', 8);

define('MOBIO_VG_REQTYPE_GIFTLIST',		1);
define('MOBIO_VG_REQTYPE_GIFTLOG_MYGIFTS',	2);
define('MOBIO_VG_REQTYPE_GIFTLOG_SENTGIFTS',	3);

$mobiovg_request_pages = array(
		MOBIO_VG_REQTYPE_GIFTLIST		=> "gift_list",
		MOBIO_VG_REQTYPE_GIFTLOG_MYGIFTS	=> "giftlog_list",
		MOBIO_VG_REQTYPE_GIFTLOG_SENTGIFTS	=> "giftlog_list"
		);

$mobiovg_request_pages = array();
$mobiovg_request_pages[MOBIO_VG_REQTYPE_GIFTLIST] 		= "gift_list";
$mobiovg_request_pages[MOBIO_VG_REQTYPE_GIFTLOG_MYGIFTS]	= "giftlog_list";
$mobiovg_request_pages[MOBIO_VG_REQTYPE_GIFTLOG_SENTGIFTS]	= "giftlog_list";

$mobiovg_ctable = 'mobio_vg_cache';
$mobiovg_cache_expire_hours = 3;
$mobiovg_cache_giftlist_expire_hours = 1;
$mobiovg_lastused_expire_hours = 3;

$mobiovg_createtable = "
CREATE TABLE `mobio_vg_cache` (
		`req_type` tinyint(3) unsigned NOT NULL default '0',
		`servID` int(10) unsigned NOT NULL default '0',
		`from_uid` bigint(20) unsigned NOT NULL default '0',
		`to_uid` bigint(20) unsigned NOT NULL default '0',
		`timestamp_requested` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
		`timestamp_lastused` timestamp NOT NULL default '0000-00-00 00:00:00',
		`timestamp_expires` timestamp NOT NULL default '0000-00-00 00:00:00',
		`result` blob,
		KEY `mobio_vg_cache` (`req_type`,`servID`,`from_uid`,`to_uid`)
		)
";

function giftdata_from_node($parent) {

	$ret['giftID'] = $parent->getElementsByTagName('giftID')->item(0) ?
		$parent->getElementsByTagName('giftID')->item(0)->textContent : '';

	$ret['name'] = $parent->getElementsByTagName('name')->item(0) ?
		$parent->getElementsByTagName('name')->item(0)->textContent : '';

	$ret['img_big'] = $parent->getElementsByTagName('img_big')->item(0) ?
		$parent->getElementsByTagName('img_big')->item(0)->textContent : '';

	$ret['img_small'] = $parent->getElementsByTagName('img_small')->item(0) ?
		$parent->getElementsByTagName('img_small')->item(0)->textContent : '';

	$ret['ordercode'] = $parent->getElementsByTagName('ordercode')->item(0) ?
		$parent->getElementsByTagName('ordercode')->item(0)->textContent : '';

	$ret['shortcode'] = $parent->getElementsByTagName('shortcode')->item(0) ?
		$parent->getElementsByTagName('shortcode')->item(0)->textContent : '';

	$ret['smsprice'] = $parent->getElementsByTagName('smsprice')->item(0) ?
		$parent->getElementsByTagName('smsprice')->item(0)->textContent : '';

	$ret['prefix'] = $parent->getElementsByTagName('prefix')->item(0) ?
		$parent->getElementsByTagName('prefix')->item(0)->textContent : '';

	$ret['glID'] = $parent->getElementsByTagName('glID')->item(0) ?
		$parent->getElementsByTagName('glID')->item(0)->textContent : '';

	$ret['gift_name'] = $parent->getElementsByTagName('gift_name')->item(0) ?
		$parent->getElementsByTagName('gift_name')->item(0)->textContent : '';

	$ret['from_uid'] = $parent->getElementsByTagName('from_uid')->item(0) ?
		$parent->getElementsByTagName('from_uid')->item(0)->textContent : '';

	$ret['from_user'] = $parent->getElementsByTagName('from_user')->item(0) ?
		$parent->getElementsByTagName('from_user')->item(0)->textContent : '';

	$ret['from_user_url'] = $parent->getElementsByTagName('from_user_url')->item(0) ? 
		$parent->getElementsByTagName('from_user_url')->item(0)->textContent : '';

	$ret['to_uid'] = $parent->getElementsByTagName('to_uid')->item(0) ?
		$parent->getElementsByTagName('to_uid')->item(0)->textContent : '';

	$ret['to_user'] = $parent->getElementsByTagName('to_user')->item(0) ?
		$parent->getElementsByTagName('to_user')->item(0)->textContent : '';

	$ret['to_user_url'] = $parent->getElementsByTagName('to_user_url')->item(0) ?
		$parent->getElementsByTagName('to_user_url')->item(0)->textContent : '';


	return $ret;
}

function HTML_mobiovg_pager($pages) {

	$w = $pages * 15;
	$p = 0;

	_echo('<div id="mobio_virtualgift_pager" style="width:'.$w.'px">');
	while($pages > 0) {
		$p += 1;
		$id = 'mobio_virtualgift_page';
		if($p == 1) $id = 'mobio_virtualgift_selectedpage';
		_echo('<span onclick="mobio_gotopage(this, '.$p.')" id="'.$id.'"></span>');
		$pages -= 1;

	}
	_echo('</div>');
}

function HTML_mobiovg_listshow($gld, $page, $from=0) {

	$style = '';
	if($page > 1) $style = 'display:none';

	_echo('<li mobio_page="'.$page.'" style="'.$style.'">');
	_echo('<a href="'.mobiovg_link("vg_page=giftshow&giftID={$gld["giftID"]}").'"><img src="'.$gld["img_small"].'"/></a>'.$gld["name"]);

	if($from and $gld["from_user"]) _echo(' от <a href="'.$gld['from_user_url'].'">'.$gld["from_user"].'</a>');
	if(!$from and $gld["to_user"]) _echo(' на <a href="'.$gld['to_user_url'].'">'.$gld["to_user"].'</a>');
	if($gld["from_uid"] == 0 and $gld["to_uid"] != 0) _echo(' от анонимко');

	_echo('</li>');
}

function HTML_mobiovg_title($title) {

	_echo('<h4 class="mobio_virtualgift_title">'.$title.'</h4>');

}

function HTML_mobiovg_show($gd) {

	_echo('<div id="mobio_virtualgift_show">');
	HTML_mobiovg_title('Подари ми '.$gd["name"]);

	_echo('<img src="'.$gd["img_big"].'"/>');

	_echo('<div id="mobio_virtualgift_orderbox">');
	_echo('изпрати <span class="smstext">'.$gd["prefix"].$gd["ordercode"].'</span> на номер <span class="shortcode">'.$gd["shortcode"].'</span>  <span="smsprice">('.$gd["smsprice"].'лв.)</span>');
	_echo('</div>');
	_echo('</div>');

	HTML_mobiovg_links(MOBIO_VG_LINK_ALLGIFTS);

}

function HTML_mobiovg_list($gifts, $from=0) {

	global $gifts_per_page;
	$page = 1;$i = 0;

	_echo('<ul id="mobio_virtualgift_list">');
	foreach($gifts as $gift) {
		$gd = giftdata_from_node($gift);

		if($i >= $gifts_per_page) {
			$i = 0;
			$page += 1;
		}
		HTML_mobiovg_listshow($gd, $page, $from);
		$i += 1;
	}
	_echo('</ul>');
}



function HTML_mobiovg_links($links) {

	_echo('<div class="mobio_links">');

	if($links & MOBIO_VG_LINK_RECVGIFTS) _echo('<a href="'.mobiovg_link("vg_page=giftlogmygifts").'">мойте подаръци</a>');
	if($links & MOBIO_VG_LINK_SENTGIFTS) _echo('<a href="'.mobiovg_link("vg_page=giftlogsentgifts").'">аз подарих</a>');
	if($links & MOBIO_VG_LINK_ALLGIFTS)  _echo('<a href="'.mobiovg_link("vg_page=giftlist").'">всички подаръци</a>');
	if($links & MOBIO_VG_LINK_ALLGIFTS2) _echo('<a href="'.mobiovg_link("vg_page=giftlist").'">изпрати ми подарък</a>');

	_echo('</div>');
	_echo('<div style="clear:both"/>');

}


function mobiovg_cacheclean($servID=0, $from_uid=0, $to_uid=0) {

	global $mobiovg_ctable, $mobiovg_lastused_expire_hours;

	settype($req_type, 'int');
	settype($servID, 'int');
	settype($from_uid, 'int');
	settype($to_uid, 'int');

	// clean expired
	// clean not used
	if(1) { // mysql connected
		
		if($servID and $to_uid) {
			$req_type = MOBIO_VG_REQTYPE_GIFTLOG_MYGIFTS;

			mysql_query("DELETE FROM $mobiovg_ctable 
					WHERE servID='$servID' AND req_type='$req_type' AND to_uid='$to_uid'");
		}

		if($servID and $from_uid) {
			$req_type = MOBIO_VG_REQTYPE_GIFTLOG_SENTGIFTS;
			mysql_query("DELETE FROM $mobiovg_ctable 
					WHERE servID='$servID' AND req_type='$req_type' AND from_uid='$from_uid'");
		}

		mysql_query("DELETE FROM $mobiovg_ctable WHERE timestamp_expires<NOW()");
		mysql_query("DELETE FROM $mobiovg_ctable WHERE 
				timestamp_lastused>DATE_ADD(NOW(), INTERVAL $mobiovg_lastused_expire_hours HOUR)");
	}
}

function mobiovg_checktable($table) {
	
	$table = mysql_real_escape_string($table);
	return mysql_query("DESC $table") ? 1 : 0;

	return 0;
}

function mobiovg_link($link) {


	if($_SERVER["QUERY_STRING"]) {

		$query_string = $_SERVER["QUERY_STRING"];
		$p = strpos($query_string, 'vg_page');
		if($p !== false) {
			if($p > 0) $p -= 1;
			$query_string = substr($query_string, 0, $p);
		}

	}

	if($query_string) {
		return '?'.$query_string.'&'.$link;

	}else{
		return '?'.$link;
	}

}

function _echo($str) {

	global $params_map;

	$encoding = $params_map['encoding'];
	if($params_map['encoding'] != 'UTF-8') {
		echo iconv('UTF-8', $encoding, $str);
	}else{
		echo $str;
	}
}

function mobiovg_dom($req_type, $servID, $from_uid=0, $to_uid=0) {

	global $mobiovg_request_pages, $mobio_url, $mobiovg_ctable, $mobiovg_cache_expire_hours,
	       $mobiovg_cache_giftlist_expire_hours;

	settype($req_type, 'int');
	settype($servID, 'int');
	settype($from_uid, 'int');
	settype($to_uid, 'int');

	$page = $mobiovg_request_pages[$req_type];

	if(!$page)
		return null;

	$dom = new DOMDocument();

	$found_in_cache = 0;



	mobiovg_cacheclean();

	$res = mysql_query("SELECT result FROM {$mobiovg_ctable} WHERE req_type='$req_type' AND 
				servID='$servID' AND 
				from_uid='$from_uid' AND 
				to_uid='$to_uid'
			");

	if(mysql_num_rows($res)) {
		$row = mysql_fetch_object($res);
		$dom->loadXML($row->result); 
		$found_in_cache = 1;
		mysql_query("UPDATE {$mobiovg_ctable} 
					SET timestamp_lastused=NOW() 
					WHERE 
					req_type='$req_type' AND 
					servID='$servID' AND 
					from_uid='$from_uid' AND 
					to_uid='$to_uid'
					");
		echo 'Loading from cache...';
	}

	

	if($found_in_cache == 0) {
		//echo "$mobio_url?page=$page&servID=$servID&to_uid=$to_uid&from_uid=$from_uid";
		$dom->load("$mobio_url?page=$page&servID=$servID&to_uid=$to_uid&from_uid=$from_uid");
		$result = $dom->saveXML();
		//echo 'HTTP request...';

		if($req_type == MOBIO_VG_REQTYPE_GIFTLIST)
			$mobiovg_cache_expire_hours = $mobiovg_cache_giftlist_expire_hours;

		mysql_query("INSERT INTO {$mobiovg_ctable} 
					(
					req_type,
					servID,
					from_uid,
					to_uid,
					timestamp_requested,
					timestamp_lastused,
					timestamp_expires,
					result

					) VALUES (

					'$req_type',
					'$servID',
					'$from_uid',
					'$to_uid',
					NOW(),
					NOW(),
					DATE_ADD(NOW(), INTERVAL $mobiovg_cache_expire_hours HOUR),
					'$result'
					)");

										
									
	}

	return $dom;

}

?>
